// C Source File
// Created 6.7.2005; 18:40:33
// Copyright (C) 2005 Ziga Mirai
//NML2Str pretvori dvo vrstino matriko primeov [number;mask]
// v string z loginim izrazom oblike "C'BA + CA'"

//Defines
//----------------------------------------------------------------------------------
#define USE_TI89              // Produce .89z File
#define RETURN_VALUE          // Return Pushed Expression
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
// #define SAVE_SCREEN        // Save/Restore LCD Contents

//>>>> UNCOMMENT THE FOLLOWING LINE to get return value stored in 'result' <<<<
//#define RETURN_VALUE result	  // Store Pushed Expression into result variable

//Includes
//----------------------------------------------------------------------------------
#include <tigcclib.h>         // Include All Header Files
#include "PomozneF.h"

//Functions
//----------------------------------------------------------------------------------
//nm2s pretvori bite n in masko m prime implikanta v string oblike ECB'A
// ciljni str mora biti vsaj 2*nbits dolg
// vrne pointer na zadnjo nilo
char* nm2s(char *str, unsigned short n, unsigned short m, short nbits) {
	short i;
	short comp=1<<(nbits-1);
	char c;
	for(i=0;i<nbits;i++) {
		if(!(m&comp)) {	//samo nemaskirane bite
			c='A'+nbits-(char)i-1;
			if(n&comp) {
				*str=c; str++;
			} else {
				*str=c; str++;
				*str='\''; str++;
			}
		}
		m<<=1;
		n<<=1;
	}
	*str=0;
	return str;
}

//Globals
//----------------------------------------------------------------------------------
char EArgs[]="E: 2-by-N-mat,uint expected!";

//Main
//----------------------------------------------------------------------------------
void _main(void)
{
	ESI ep=top_estack;
	
	//preveri e sta dva parametra: ena matrika z 2 vrsticama in en int
	if(remaining_element_count(ep)!=2) ETxtExit(EArgs);
	if(GetArgType(ep)!=LIST_TAG || GetArgType(ep-1)!=LIST_TAG) ETxtExit(EArgs);
	if(remaining_element_count(ep-1)!=2) ETxtExit(EArgs);
	if(GetArgType(next_expression_index(ep))!=POSINT_TAG) ETxtExit(EArgs);
	ep--;	//kae na prvo vrstico matrike
	
	long nelems=remaining_element_count(ep-1);
	short rown[nelems],rowm[nelems];
	ep=LoadShortIntList(rown,ep);
	ep=LoadShortIntList(rowm,ep);
	ep--;
	short nBits=GetIntArg(ep);
	if(nBits>16) nBits=16;
	
	char rstr[nelems*nBits*2+nelems*3+1];
	char *p=rstr;
	
	short e;
	for(e=0;e<nelems;e++) {
		p=nm2s(p, rown[e],rowm[e], nBits);
		sprintf(p," + ");
		p+=3;
	}
	*(p-3)=0;
	
	top_estack=PushString(ep, rstr);
}
