// C Header File
// Created 2.7.05; 22:00
//Copyright (C) 2005 iga Mirai

//Help functions
//----------------------------------------------------------------------------------

//GetBtmESI kae na zakljuni END_TAG stacka ali pa liste e si znotraj nje
// stack je takle: END_TAG, tag, ... tag, tag, end_tag,elementi,list_tag, ...
// prvi END_TAG oznacuje konec celotnega sklada
ESI GetBtmESI(ESI sp) {
  while(GetArgType(sp) != END_TAG)
  	sp=next_expression_index(sp);
  return sp;
}

//poje preostale argumente na stacku
// END_TAG na zaetku stacka pove: sledijo argumenti funkcije
// e nima ni za vrniti ga mora pred vrnitvijo pojesti da se ne obesi
// e pa ima, je to lahko le en sam argument (ta se potem izpie)
#define EatArgs() top_estack=GetBtmESI(top_estack)-1
//Vedno se najprej povea top_estack nato zapie kvant, tako da
// top_estack kae na nek tag ne pa na nasledje prazno mesto
//e najprej poje vse na stacku nato pa elel nekaj vrniti
// najprej porini END_TAG, nato pa argument za vrniti


//na ESI ep porine zero terminated string str in
// vrne povean ep, ki kae na STR_TAG
ESI PushString(ESI ep, char *str) {
	ep++;
	*ep=0;
	strcpy(ep+1, str);
	ep+=strlen(str)+2;
	*ep=STR_TAG;
	return ep;
}

//Izpie error string in kona
// za kjerkoli v programu
void ETxtExit(char *str) {
	EatArgs();
	push_quantum(END_TAG);
	top_estack=PushString(top_estack, str);
	exit(0);
}


//LoadShortIntList Naloi listo l[] z inti
//ep mora kazat na LIST_TAG
//po koncu vrnjen ep kae pod END_TAG prebrane liste
char EListExpected[]="E: List expected!";
char EIntExpected[]="E: Int expected!";
ESI LoadShortIntList(short int *l, ESI ep) {
	if(GetArgType(ep)!=LIST_TAG) ETxtExit(EListExpected);
	ep--;
	unsigned short N=remaining_element_count(ep);
	unsigned short i;
	for(i=0; i<N; i++) {
		char at=GetArgType(ep);
		if((at!=POSINT_TAG) && (at!=NEGINT_TAG)) ETxtExit(EIntExpected);
		l[i]=GetIntArg(ep);
	}
	return ep-1;
}
