// C Source File
// Created 6.7.2005; 18:40:33
// Copyright (C) 2005 Ziga Mirai

//NML2Str converts a two-rows primes matrix [numbers;masks]
// into a string containing logical expression of the form "C'BA + CA'"

//2006.04.07 comments translation

//Defines
//----------------------------------------------------------------------------------
#define USE_TI89              // Produce .89z File
#define RETURN_VALUE          // Return Pushed Expression
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
// #define SAVE_SCREEN        // Save/Restore LCD Contents

//>>>> UNCOMMENT THE FOLLOWING LINE to get return value stored in 'result' <<<<
//#define RETURN_VALUE result	  // Store Pushed Expression into result variable

//Includes
//----------------------------------------------------------------------------------
#include <tigcclib.h>         // Include All Header Files
#include "HelperF.h"

//Functions
//----------------------------------------------------------------------------------
//nm2s converts bits n and mask m of a prime implicant to a string of the form "ECB'A"
// the length of the destination string must be at least 2*nbits
// returns pointer to the last zero
char* nm2s(char *str, unsigned short n, unsigned short m, short nbits) {
	short i;
	short comp=1<<(nbits-1);
	char c;
	for(i=0;i<nbits;i++) {
		if(!(m&comp)) {	//only unmasked bits
			c='A'+nbits-(char)i-1;
			if(n&comp) {
				*str=c; str++;
			} else {
				*str=c; str++;
				*str='\''; str++;
			}
		}
		m<<=1;
		n<<=1;
	}
	*str=0;
	return str;
}

//Globals
//----------------------------------------------------------------------------------
char EArgs[]="E: 2-by-N-mat,uint expected!";

//Main
//----------------------------------------------------------------------------------
void _main(void)
{
	ESI ep=top_estack;

	//check if there are two parameters: one matrix with 2 rows and one int
	if(remaining_element_count(ep)!=2) ETxtExit(EArgs);
	if(GetArgType(ep)!=LIST_TAG || GetArgType(ep-1)!=LIST_TAG) ETxtExit(EArgs);
	if(remaining_element_count(ep-1)!=2) ETxtExit(EArgs);
	if(GetArgType(next_expression_index(ep))!=POSINT_TAG) ETxtExit(EArgs);
	ep--;	//points to the first row of the matrix

	long nelems=remaining_element_count(ep-1);
	short rown[nelems],rowm[nelems];
	ep=LoadShortIntList(rown,ep);
	ep=LoadShortIntList(rowm,ep);
	ep--;
	short nBits=GetIntArg(ep);
	if(nBits>16) nBits=16;

	char rstr[nelems*nBits*2+nelems*3+1];
	char *p=rstr;

	short e;
	for(e=0;e<nelems;e++) {
		p=nm2s(p, rown[e],rowm[e], nBits);
		sprintf(p," + ");
		p+=3;
	}
	*(p-3)=0;

	top_estack=PushString(ep, rstr);
}
