// C Header File
// Created 3.7.05; 22:00
//Copyright (C) 2005 Ziga Mirai

unsigned short Is1Near(unsigned short a, unsigned short b) {
	a^=b;
	b=a;
	if(a!=0) {
		while((a&1)==0) a>>=1;
		if(a!=1) b=0;
	}
	return b;
}

//Insertion sort polja a[] doline N - ascending
void InsSortShort1(short *a, long N) {
	long i,j;
	short e;
	for(i=1;i<N;i++) {
		e=a[i];
		j=i;
		while(e<a[j-1] && j>0) {
			a[j]=a[j-1];
			j--;
		}
		a[j]=e;
	}
}

//V polju a[] pusti le razline elemente
// N zaetna dolina polja
// vrne dolino skrajanega polja
long LReduceShort1(short *a, long N) {
	long i,j;
	long ni=1; //nova dolina polja
	short e;
	for(i=1;i<N;i++) {
		//vsak len primerjaj s tistimi, ki so e na levi
		e=a[i];
		for(j=0;j<ni && e!=a[j];j++);
		if(j==ni) {
			a[ni]=e;
			ni++;
		}
	}
	return ni;
}

//V poljih a[] in b[] pusti le razline pare elementov
// N zaetna dolina polja
// vrne dolino skrajanega polja
long LReduceShort2(short *a, short *b, long N) {
	long i,j;
	long ni=1; //nova dolina polja
	short e,f;
	for(i=1;i<N;i++) {
		//vsak len primerjaj s tistimi, ki so e na levi
		e=a[i];
		f=b[i];
		for(j=0;j<ni && (e!=a[j] || f!=b[j]);j++);
		if(j==ni) {
			a[ni]=e;
			b[ni]=f;
			ni++;
		}
	}
	return ni;
}

//V polju a[] doline N pusti le razlina podpolja doline M
// N zaetna dolina polja, M dolina podpolj
// vrne dolino skrajanega polja
long LReduceShortSubL1(short *a, long N, long M) {
	long Ml=M*sizeof(short);
	long i,j;
	long ni=M; //nova dolina polja a[]
	short *psubl;
	for(i=M;i<N;i+=M) {
		//vsako podlisto primerjaj s tistimi, ki so e na levi
		psubl=&a[i];
		for(j=0; j<ni && memcmp(psubl, &a[j], Ml)!=0; j+=M);
		if(j==ni) {
			memcpy(&a[ni], psubl, Ml);
			ni+=M;
		}
	}
	return ni;
}

