// C Header File
// Created 2.7.05; 22:00
//Copyright (C) 2005 iga Mirai

// 06.04.2006; 20:01
//  comments translation

//Help functions
//----------------------------------------------------------------------------------

//GetBtmESI points to the ending END_TAG of a stack or of a list if inside it
// stack looks like: END_TAG, tag, ... tag, tag, END_TAG, elements, list_tag, ...
// first END_TAG marks the end of entire stack
ESI GetBtmESI(ESI sp) {
  while(GetArgType(sp) != END_TAG)
  	sp=next_expression_index(sp);
  return sp;
}

//eats remaining aruments on the stack
// END_TAG at the beginning of the stack means: function arguments follow
// if there's nothing to return, it has to be eaten before returning to prevent hang up
// if there is, then it should only be one argument (this one is then printed)
#define EatArgs() top_estack=GetBtmESI(top_estack)-1
//Allways: top_estack is incremented first, then quantum is written, so that
// top_estack points to some tag instead to a next empty space
//If you first eat everything on the stack and then want to insert something
// then first push END_TAG, and then an argument to be insterted


//pushes zero terminated string str to the ESI ep
// and returns increased ep that points to the STR_TAG
ESI PushString(ESI ep, char *str) {
	ep++;
	*ep=0;
	strcpy(ep+1, str);
	ep+=strlen(str)+2;
	*ep=STR_TAG;
	return ep;
}

//Prints out an error string and exits
// to be used wherever in a program
void ETxtExit(char *str) {
	EatArgs();
	push_quantum(END_TAG);
	top_estack=PushString(top_estack, str);
	exit(0);
}


//02.07.2005
//PushLongInt to the chosen stack
ESI PushLongInt(ESI ep, long a) {
	char i=0, tag=POSINT_TAG;
	ep++;
	if(a==0) {
		*ep=0; ep++;
	} else {
		if(a<0) {
			a=-a;
			tag=NEGINT_TAG;
		}
		while(a!=0) {
			*ep=(char)a; ep++;
			a>>=8;
			i++;
		};
		*ep=i; ep++;
	}
	*ep=tag;
	return ep;
}

//PushShortIntList to the selected stack
ESI PushShortIntList(ESI ep, short *list, short count) {
	short i;
	*ep++;
	*ep=END_TAG;
	for(i=count-1;i>=0;i--) {
		ep=PushLongInt(ep, list[i]);
	}
	*ep++;
	*ep=LIST_TAG;
	return ep;
}


//LoadShortIntList loads list l[] with ints from a list on the stack ep
//ep should point to the LIST_TAG
//retuned ep points under the END_TAG of the read list
char EListExpected[]="E: List expected!";
char EIntExpected[]="E: Int expected!";
ESI LoadShortIntList(short int *l, ESI ep) {
	if(GetArgType(ep)!=LIST_TAG) ETxtExit(EListExpected);
	ep--;
	unsigned short N=remaining_element_count(ep);
	unsigned short i;
	for(i=0; i<N; i++) {
		char at=GetArgType(ep);
		if((at!=POSINT_TAG) && (at!=NEGINT_TAG)) ETxtExit(EIntExpected);
		l[i]=GetIntArg(ep);
	}
	return ep-1;
}
