// C Header File
// Created 3.7.05; 22:00
//Copyright (C) 2005 Ziga Mirai

//2006.04.06 comments translation

//do a and b differ by one and only one bit
// if true => return mask of that bit position
// if false => return 0
unsigned short Is1Near(unsigned short a, unsigned short b) {
	a^=b;
	b=a;
	if(a!=0) {
		while((a&1)==0) a>>=1;
		if(a!=1) b=0;
	}
	return b;
}

//Insertion sort array a[] of length N - ascending
void InsSortShort1(short *a, long N) {
	long i,j;
	short e;
	for(i=1;i<N;i++) {
		e=a[i];
		j=i;
		while(e<a[j-1] && j>0) {
			a[j]=a[j-1];
			j--;
		}
		a[j]=e;
	}
}

//Leave only differing elements in array a[]
// N initial array length
// returns length of shortened array
long LReduceShort1(short *a, long N) {
	long i,j;
	long ni=1; //new array length
	short e;
	for(i=1;i<N;i++) {
		//compare each element with those already on the left
		e=a[i];
		for(j=0;j<ni && e!=a[j];j++);
		if(j==ni) {
			a[ni]=e;
			ni++;
		}
	}
	return ni;
}

//Leave only differing pairs of elements in arrays a[] and b[]
// N initial array length
// returns length of shortened array
long LReduceShort2(short *a, short *b, long N) {
	long i,j;
	long ni=1; //new array length
	short e,f;
	for(i=1;i<N;i++) {
		//compare each element with those already on the left
		e=a[i];
		f=b[i];
		for(j=0;j<ni && (e!=a[j] || f!=b[j]);j++);
		if(j==ni) {
			a[ni]=e;
			b[ni]=f;
			ni++;
		}
	}
	return ni;
}

//Leave only differing subarrays of length M in array a[] of length N
// N initial array length, M length of a subarray
// returns length of shortened array
long LReduceShortSubL1(short *a, long N, long M) {
	long Ml=M*sizeof(short);
	long i,j;
	long ni=M; //new length of the array a[]
	short *psubl;
	for(i=M;i<N;i+=M) {
		//compare each subarray with those already on the left
		psubl=&a[i];
		for(j=0; j<ni && memcmp(psubl, &a[j], Ml)!=0; j+=M);
		if(j==ni) {
			memcpy(&a[ni], psubl, Ml);
			ni+=M;
		}
	}
	return ni;
}

